
//    (Brenkman Andrey)
//   20.11.2010

//!
#include "a_All_constants.h"

// List_surplus_moves_generator.cpp
#define KONTROL_B 0 // -(1-0)   

// i_List_surplus_moves_insert.cpp
#define TEST_H 0 
/*

 List_surplus_moves
     
     
 :
  
  

1.
 List_surplus_moves_generator.cpp

    99%

  (bit board) 
           
   :
 "Hyatt, Robert. Rotated bitmaps, a new twist on an old idea"
         :)

      Chess_bitboard   
            
 +   

              
            

 
        
   (21.02.09) (bugs)  
 
2.
	List_surplus_moves_sorting.cpp


3.
	List_surplus_moves_insert.cpp


*/

//---------------------------------------------------------------------------
//    
class List_surplus_moves 
{
	//         
	friend class Chess_bitboard;

//  
//////////////////////////////////////////////////////////////////////////////////////
private:
//public:

	/*
	    move     ( 27 )
	--3 --      --6 --   --6 --     --6 --  --6 -- 
	              

	//-------------------------------------------------
	  ..   
	--6 -- 
	 

	0 -  
	1 -  
	2 -  
	3 - 
	4 -  
	5 -  
	6 - 

	 move =  
	  move & 63 ( 63  ...000111111)

	//-------------------------------------------------
	--6 --
	 

	0 -  
	1   
	2  
	3   
	4   
	5    

	12 -    
	13 -   
	14 -    
	15 -    

	22 -      
	23 -     
	24 -      
	25 -      
 
	 move = move | (  << 6)
	 (move>>6) & 63

	//-------------------------------------------------
	--6 --
	  (0 -63)
	 move = move | (  << 12)
	 (move>>12) & 63

	//-------------------------------------------------
	--6 --
	  (0 -63)
	 move = move | (  << 18)
	 (move>>18) & 63

	//-------------------------------------------------
	--3 -- 
	 
	0 -  
	1 -  
	2 -  
	3 - 
	4 -  
	5 -  
	6 - 
	 move = move | (  << 24)
	 (move>>24) & 7 ( 7  ...000111)
	*/
	__int32 move[MAX_MOVE];

	//     
	__int32 sorting_score[MAX_MOVE];

	//         .   
	// (       )
	unsigned __int8 end_captures;

	//       ..  
	unsigned __int8 end_list;


//    
//////////////////////////////////////////////////////////////////////////////////////
public:

	// 
	inline __int32 get_move(const unsigned __int16 n)
	{
		return move[n];
	};

	//      
	inline __int32 get_sorting_score(const unsigned __int16 n)
	{
		return sorting_score[n];
	};

	//         .   
	inline unsigned __int8 get_end_captures()
	{
		return end_captures;
	};

	//       ..  
	inline unsigned __int8 get_end_list()
	{
		return end_list;
	};


//   
//////////////////////////////////////////////////////////////////////////////////////
public:

	//      
	inline void set_sorting_score(const unsigned __int16 n, const __int32 _sorting_score)
	{
		sorting_score[n] = _sorting_score;
	};


//   
// List_surplus_moves_generator.cpp
//////////////////////////////////////////////////////////////////////////////////////
public:

	//---------------------------------------------------------------------------
	//    +   ( )
	void generator_captures_white
	(
		const class Chess_bitboard & bitboard//              
	);

	//---------------------------------------------------------------------------
	//     +   ( )
	void generator_captures_black
	(
		const class Chess_bitboard & bitboard//  
	);

	//---------------------------------------------------------------------------
	//     
	// (..     +  )( )
	void generator_move_white
	(
		const class Chess_bitboard & bitboard//  
	);

	//---------------------------------------------------------------------------
	//     
	// (..     +  )( )
	void generator_move_black
	(
		const class Chess_bitboard & bitboard//  
	);

	//              

	//---------------------------------------------------------------------------
	//           
	//  0    
	unsigned __int8 king_white_check
	(
		const class Chess_bitboard & bitboard//  
	);

	//---------------------------------------------------------------------------
	//           
	//  0    
	unsigned __int8 king_black_check
	(
		const class Chess_bitboard & bitboard//  
	);

//   
// List_surplus_moves_generator.cpp
//////////////////////////////////////////////////////////////////////////////////////
private:

	//            

	//---------------------------------------------------------------------------
	//           
	//  0    
	inline unsigned __int8 white_check_square
	(
		const unsigned __int8 & sq,//  (0-63) 
		const class Chess_bitboard & bitboard//  
	);

	//---------------------------------------------------------------------------
	//           
	//  0    
	inline unsigned __int8 black_check_square
	(
		const unsigned __int8 & sq,//  (0-63) 
		const class Chess_bitboard & bitboard//  
	);

	//---------------------------------------------------------------------------
	//    -   
	//        ( )
	inline void list_capture_white
	(
		const unsigned __int8 name,//   
		const unsigned __int8 type_move,//  
		const unsigned __int8 & from,//  
		const unsigned __int8 & to,//  
		unsigned __int8 & count,//    
		const class Chess_bitboard & bitboard//  
	);

	//---------------------------------------------------------------------------
	//    -   
	//        ( )
	inline void list_capture_black
	(
		const unsigned __int8 name,//   
		const unsigned __int8 type_move,//  
		const unsigned __int8 & from,//  
		const unsigned __int8 & to,//  
		unsigned __int8 & count,//    
		const class Chess_bitboard & bitboard//  
	);

	//---------------------------------------------------------------------------
	//   
	inline void list_record_move
	(
		const unsigned __int8 name,//   
		const unsigned __int8 type_move,//  
		const unsigned __int8 & from,//  
		const unsigned __int8 & to,//  
		unsigned __int8 & count,//    
		const class Chess_bitboard & bitboard//  
	);

	//---------------------------------------------------------------------------
	//         
	//      
	inline void list_record_special
	(
		const unsigned __int8 name,//   
		const unsigned __int8 d_m,//  
		unsigned __int8 & count,//    
		const unsigned __int8 & from,//  
		const unsigned __int8 to,//  
		const unsigned __int8 capture//   
	);

	//---------------------------------------------------------------------------
	//     ,         
	//       
	inline void KONTROL_captures_W
	(
		const class Chess_bitboard & bitboard,//  
		const unsigned __int8 & from,//   
		const unsigned __int8 & to,//   
		const unsigned __int8 & p,//    
		const unsigned __int8 name_figure//   
	);

	//---------------------------------------------------------------------------
	//     ,         
	//       
	inline void KONTROL_captures_B
	(
		const class Chess_bitboard & bitboard,//  
		const unsigned __int8 & from,//   
		const unsigned __int8 & to,//   
		const unsigned __int8 & p,//    
		const unsigned __int8 name_figure//   
	);

	//---------------------------------------------------------------------------
	//     ,    
	//    
	inline void KONTROL_move
	(
		const unsigned __int8 & from,//   
		const unsigned __int8 & to,//   
		const unsigned __int8 & p//    
	);


//////////////////////////////////////////////////////////////////////////////////////
public:

	//---------------------------------------------------------------------------
	//    (..  )
	__inline __int32 bit_scan_forward_win32
	(
		const unsigned __int64 analyzed_number//      
	);

	//---------------------------------------------------------------------------
	//    (..  )
	__inline __int32 bit_scan_reverse_win32
	(
		const unsigned __int64 analyzed_number//      
	);


//   
// List_surplus_moves_sorting.cpp
//////////////////////////////////////////////////////////////////////////////////////
public:

	//---------------------------------------------------------------------------
	//  
	void sorting_moves();

	//---------------------------------------------------------------------------
	//    
	void sorting_white_moves_root();

	//---------------------------------------------------------------------------
	//    
	void sorting_black_moves_root();


//   
//  List_surplus_moves_insert.cpp
//////////////////////////////////////////////////////////////////////////////////////
public:

	//---------------------------------------------------------------------------
	//     ( start) 
	void insert_killer_in_list
	(
		const __int32 killer_moves_1,// 
		const __int32 killer_moves_2,//
		const unsigned __int8 start//        
	);


//   
// List_surplus_moves_insert.cpp
//////////////////////////////////////////////////////////////////////////////////////
public:

	//---------------------------------------------------------------------------
	//  -          
	void insert_hash_moves
	(
		const __int32 hash_moves,//
		unsigned __int8  & flag_insert_hash_move//     -     
	);

};